#!/bin/bash

user_ftp="" #user
password_ftp="" #password
ip_host="" #indirizzo ip
c_backup="/mnt/usb/backup/" #cartella di backup
ftp_folder="/mnt/ftp" #cartella backup

E='echo -e'
e='echo -en'
trap "R;exit" 2
ESC=$( $e "\e")

TPUT()
{
        $e "\e[${1};${2}H"
}

CLEAR()
{
        $e "\ec"
}

CIVIS()
{
        $e "\e[?25l";
}

DRAW()
{
        $e "\e%@\e(0";
}

WRITE()
{
        $e "\e(B";
}

MARK()
{
        $e "\e[7m";
}

UNMARK()
{
        $e "\e[27m";
}

R()
{
        CLEAR
        stty sane
}

HEAD()
{
        DRAW
        for each in $(seq 1 12)
        do
                $E "    |                                        |"
        done
        WRITE
        MARK
        TPUT 1 5
        $E "              UTILITY MENU                "
        UNMARK
}

i=0
CLEAR
CIVIS
NULL=/dev/null

FOOT()
{
        MARK
        TPUT 12 5
        printf "           SELEZIONA E PREMI ENTER        "
        UNMARK
}

ARROW()
{
        read -s -n3 key 2>/dev/null >&2
        if [[ $key = $ESC[A ]]
        then
                echo up
        fi
        if [[ $key = $ESC[B ]]
        then
                echo dn
        fi
}

M0()
{
        TPUT  4 20
        $e "Mount USB"
}

M1()
{
        TPUT  5 20
        $e "Umount USB"
}

M2()
{
        TPUT  6 20
        $e "Disk"
}

M3()
{
        TPUT  7 20
        $e "Backup"
}

M4()
{
        TPUT  8 20
        $e "EXIT"
}


LM=4

MENU()
{
        for each in $(seq 0 $LM)
        do
                M${each}
        done
}

POS()
{
        if [[ $cur == up ]]
        then
                ((i--))
        fi

        if [[ $cur == dn ]]
        then
                ((i++))
        fi

        if [[ $i -lt 0   ]]
        then
                i=$LM
        fi

        if [[ $i -gt $LM ]]
        then
                i=0
        fi
}

REFRESH()
{
        after=$((i+1))
        before=$((i-1))

        if [[ $before -lt 0  ]]
        then
                before=$LM
        fi

        if [[ $after -gt $LM ]]
        then
                after=0
        fi

        if [[ $j -lt $i      ]]
        then
                UNMARK
                M$before
        else
                UNMARK
                M$after
        fi

        if [[ $after -eq 0 ]] || [ $before -eq $LM ]
        then
                UNMARK
                M$before
                M$after
        fi

        j=$i
        UNMARK
        M$before
        M$after
}

INIT()
{
        R
        HEAD
        FOOT
        MENU
}

SC()
{
        REFRESH
        MARK
        $S
        $b
        cur=`ARROW`
}

ES()
{
        MARK
        $e "ENTER per tornare al men principale "
        $b
        read
        INIT
}

INIT

while [[ "$O" != " " ]]
do
        case $i in
                0)
                        S=M0
                        SC
                        if [[ $cur == "" ]]
                        then
                                R
                                $e "\n$(sudo mount -t ntfs-3g /dev/sda1 /mnt/usb/)\n"
                                ES
                        fi
                        ;;
                1)
                        S=M1
                        SC
                        if [[ $cur == "" ]]
                        then
                                R
                                $e "\n$(sudo umount /dev/sda1 )\n"
                                ES
                        fi
                        ;;
                2)
                        S=M2
                        SC
                        if [[ $cur == "" ]]
                        then
                                R
                                $e "\n$(df -h    )\n"
                                ES
                        fi
                        ;;
                3)
                        S=M3
                        SC
                        if [[ $cur == "" ]]
                        then
                                R
                                sudo curlftpfs ftp://$user_ftp:$password_ftp@$ip_host $ftp_folder
                        #       sudo rm $rsync_log
                                sudo rsync -8rtv $ftp_folder $c_backup
                        #       exit_code_rsync="$?"
                                sudo umount $ftp_folder
                                ES
                        fi
                        ;;
                4)
                        S=M4
                        SC
                        if [[ $cur == "" ]]
                        then
                                R
                                return
                        fi
                        ;;
        esac
        POS
done
exit 0
